var TEValues = [];

function pad(c) {
    var i = parseInt(c, 10);
    if (i>=0)
        return (i < 10 ? '0' + i : c.toString());
    else
        return (i <= -10 ? c.toString(): '-0' + Math.abs(i) );
}

function formatTime(val) {
    if (val == null)
        return "-";
    return "" + pad(Math.floor(val / 3600)) + ":" + pad(Math.floor(val / 60) % 60) + ":" + pad(val % 60);
}

function buildRow(oObject) {
    var sString = '<tr style="background-color:#CCCCCC;">';
    sString += '<td width="50px">ID:</td><td><b>' + oObject.id + "</b></td>";
    sString += '<td width="50px">Name:</td><td><b>' + oObject.name + "</b></td>";
    sString += '<td>Zeitbasis:</td><td width="150px"><b>' + oObject.timeBase
    if (oObject.propertyReference!=null) 
        sString += '<br>(' + oObject.propertyReference + ')';
    sString +=  "</b></td>";
    sString += "<td>Zeitoffset:</td><td><b>" + formatTime(oObject.offset) + '</b></td></tr><tr>';
    sString += "<td>Limit min:</td><td><b>" + formatTime(oObject.limitBefore) + "</b></td>";
    sString += "<td>Limit max:</td><td><b>" + formatTime(oObject.limitAfter) + "</b></td>";
    if (oObject.recurrence != null) {
        sString += '<td>Wiederholung</td><td><b>';
        for ( var iIndex = 0; iIndex < oObject.recurrence.length; iIndex++)
            sString += oObject.recurrence[iIndex] + ', ';
    } else {
        sString += '<td>Zeiten</td><td><b>';
        for ( var iIndex = 0; iIndex < oObject.dates.length; iIndex++)
            sString += oObject.dates[iIndex];
    }
    if (oObject.random!=null)
        sString += '</b></td><td>Random:</td><td><b>'+ oObject.random;
    sString += '</b></td></tr><tr style="background-color:#CCCCCC;">';
    var sStringSub = "";
    var iColspan = 0;
    for ( var sKey in oObject.conditions) {
        sStringSub += '<td><b>' + sKey + '</b></td><td colspan="5"><b>' + oObject.conditions[sKey] + '</b></td></tr><tr>';
        iColspan++;
    }
    if (iColspan > 0) {
        sString += '<td colspan="2" rowspan="' + iColspan + '">Bedingungen:</td>' + sStringSub;
    }
    iColspan = 0;
    sStringSub = "";
    for ( var iIndex = 0; iIndex < oObject.actions.length; iIndex++) {
        var sStringSubSub = "";
        var iColColspan = 0;
        for ( var sKey in oObject.actions[iIndex]) {
            iColColspan++;
            var sText=oObject.actions[iIndex][sKey];
            switch(sKey) {
                case 'zone':
                    sText=getNameForZone(oObject.actions[iIndex].zone) + "(" + sText + ")";
                    break;
                case 'group':
                    if (oObject.actions[iIndex].zone!=null)
                        sText=getNameForGroup(oObject.actions[iIndex].zone,oObject.actions[iIndex].group) + "(" + sText + ")";
                    break;
                case 'scene':
                    if (oObject.actions[iIndex].zone!=null)
                        if (oObject.actions[iIndex].group!=null)
                            sText=getNameForScene(oObject.actions[iIndex].zone,oObject.actions[iIndex].group,oObject.actions[iIndex].scene) + "(" + sText + ")";
                    if (oObject.actions[iIndex].dsid!=null) {
                        var device=getDevice(oObject.actions[iIndex].dsid);
                        sText=getNameForScene(device.ZoneID,(device.functionID>>12),oObject.actions[iIndex].scene) + "(" + sText + ")";
                    }
                    break;
                case 'dsid':
                    sText=getDevice(oObject.actions[iIndex].zone).name + "(" + sText + ")";
                    break;
            }
            sStringSubSub += '<td><b>' + sKey + '</b></td><td><b>' + sText + "</b></tr><tr>";
        }
        sStringSub += '<td colspan="6"><hr></td></tr><tr><td rowspan="' + iColColspan + '" colspan="2">Aktion #' + (iIndex + 1) + ':</td>' + sStringSubSub  ;
        iColspan += iColColspan+1;
    }
    if (iColspan > 0) {
        sString += '<td colspan="2" rowspan="' + iColspan + '">Aktionen:</td>' + sStringSub;

    }
    
    sString += '<td colspan="8"><hr></td></tr>';
    return sString;
}

function init() {
    initValues();

    var sResult = ajaxSyncRequest('/json/property/query', {
        'query' : '/scripts/system-addon-timed-events/entries/*(*)/*(*)/*(*)'
    });
    var resultObj = JSON.parse(sResult);
    if (resultObj.ok) {
        for ( var iIndex = 0; iIndex < resultObj.result.entries.length; iIndex++) {
            var subObj = resultObj.result.entries[iIndex];
            var oObject = {};
            oObject.name = subObj.name;
            oObject.id = subObj.id;
            oObject.conditions = {};
            var oSubObj = null;
            for (var sKey in subObj) {
                if (typeof(subObj[sKey])=='object')
                    oSubObj=subObj[sKey];
            }
            for ( var jIndex = 0; jIndex < oSubObj.length; jIndex++) {
                if (oSubObj[jIndex].actions != null) {
                    oObject.actions = oSubObj[jIndex].actions;
                }
                if (oSubObj[jIndex].timeBase != null)
                    oObject.timeBase = oSubObj[jIndex].timeBase;
                if (oSubObj[jIndex].limitBefore != null)
                    oObject.limitBefore = oSubObj[jIndex].limitBefore;
                if (oSubObj[jIndex].limitAfter != null)
                    oObject.limitAfter = oSubObj[jIndex].limitAfter;
                if (oSubObj[jIndex].timeBase != null)
                    oObject.timeBase = oSubObj[jIndex].timeBase;
                if (oSubObj[jIndex].offset != null)
                    oObject.offset = oSubObj[jIndex].offset;
                if (oSubObj[jIndex].recurrenceBase != null)
                    oObject.recurrenceBase = oSubObj[jIndex].recurrenceBase;
                if (oSubObj[jIndex].time != null) {                    
                    if (oObject.recurrenceBase == 'weekly') {
                        oObject.recurrence = [];
                        for ( var kIndex = 0; kIndex < oSubObj[jIndex].time.length; kIndex++) {
                            if (oSubObj[jIndex].time[kIndex]) {
                                for ( var sKey in oSubObj[jIndex].time[kIndex]) {
                                    oObject.recurrence.push(oSubObj[jIndex].time[kIndex][sKey]);
                                }
                            }
                        }
                    } else {
                        oObject.dates = [];
                        for ( var kIndex = 0; kIndex < oSubObj[jIndex].time.length; kIndex++) {
                            if (oSubObj[jIndex].time[kIndex]) {
                                for ( var sKey in oSubObj[jIndex].time[kIndex]) {
                                    oObject.dates.push(oSubObj[jIndex].time[kIndex][sKey]);
                                }
                            }
                        }
                    }
                    if (oSubObj[jIndex].propertyReference!=null)
                        oObject.propertyReference=oSubObj[jIndex].propertyReference;
                    if (oSubObj[jIndex].random!=null)
                        oObject.random=oSubObj[jIndex].random;
                }
                if (oSubObj[jIndex].enabled) {
                    oObject.conditions.enabled = oSubObj[jIndex].enabled;
                }
                if (oSubObj[jIndex].conditions) {
                    for ( var kIndex = 0; kIndex < oSubObj[jIndex].conditions.length; kIndex++) {
                        for ( var sKey in oSubObj[jIndex].conditions[kIndex])
                            oObject.conditions[sKey] = oSubObj[jIndex].conditions[kIndex][sKey];
                    }
                }
            }
            TEValues.push(oObject);
        }
    }
    var sString = '<table width="100%"><tr><td colspan="8"><hr></td></tr>';
    for ( var iIndex = 0; iIndex < TEValues.length; iIndex++)
        sString += buildRow(TEValues[iIndex]);
    document.getElementById('liste').innerHTML = sString + "</table>";
}
